# Load libraries
from machine import Pin
from time import sleep

# Initialization of GPIO16, GPIO17 and GPIO18 as input
CLK = Pin(16,Pin.IN, Pin.PULL_DOWN)
DT = Pin(17,Pin.IN, Pin.PULL_DOWN)
switch = Pin(18,Pin.IN, Pin.PULL_UP)

# Variables definition
counter = 0
PIN_CLK_LETZTER = 0
PIN_CLK_AKTUELL = 0
Richtung = True
PIN_CLK_LETZTER = CLK.value()

print("----------------------------------------------------")

def ausgabe():
    Blue = CLK.value()
    Purple = DT.value()
    global PIN_CLK_AKTUELL
    global counter
    global Richtung

    # Reading out the current status 
    PIN_CLK_AKTUELL = Blue

    # Change review
    if PIN_CLK_AKTUELL != PIN_CLK_LETZTER:

        # Pin_CLK changed first
        if Purple != PIN_CLK_AKTUELL:
            counter = counter + 1
            Richtung = True

        # Otherwise Pin_DT has changed first
        else:
            Richtung = False
            counter = counter - 1
        print("Rotation detected: ")

        if Richtung:
            print("Direction of rotation: Clockwise")
        else:
            print("Direction of rotation: Counterclockwise")
        print("Current position: " + str(counter))
        print("-------------------------------------------")

# Function: Counter variable is reset when the button is pressed
def CounterReset():
    global counter
    if switch.value() == 0:
        print("Position resetted!")
        print("-----------------------")
        counter = 0
        sleep(0.5)

# Endless loop for constant readout of the sensor
while True:
    ausgabe()
    PIN_CLK_LETZTER = PIN_CLK_AKTUELL
    CounterReset()